<!-- Captcha Settings -->

<?php

$captcha_type = $this -> get_option('captcha_type');

?>

<table class="form-table">
	<tbody>
		<tr>
			<th><label for="captcha_type_none"><?php _e('Captcha Type', 'wp-mailinglist'); ?></label>
			<?php echo $Html -> help(__('Choose the type of captcha security image you want to use or select "None" for no captcha.', 'wp-mailinglist')); ?></th>
			<td>
				<label><input onclick="jQuery('#recaptcha_div').hide(); jQuery('#rsc_div').hide();" <?php echo (empty($captcha_type) || $captcha_type == "none") ? 'checked="checked"' : ''; ?> type="radio" name="captcha_type" value="none" id="captcha_type_none" /> <?php _e('None', 'wp-mailinglist'); ?></label>
				<label><input onclick="jQuery('#recaptcha_div').show(); jQuery('#rsc_div').hide();" <?php echo (!empty($captcha_type) && $captcha_type == "recaptcha") ? 'checked="checked"' : ''; ?> type="radio" name="captcha_type" value="recaptcha" id="captcha_type_recaptcha" /> <?php _e('reCAPTCHA', 'wp-mailinglist'); ?></label>
				<label><input onclick="jQuery('#recaptcha_div').hide(); jQuery('#rsc_div').show();" <?php echo (!empty($captcha_type) && $captcha_type == "rsc") ? 'checked="checked"' : ''; ?> type="radio" name="captcha_type" value="rsc" id="captcha_type_rsc" <?php echo (!$this -> is_plugin_active('captcha')) ? 'disabled="disabled"' : ''; ?> /> <?php _e('Really Simple Captcha', 'wp-mailinglist'); ?></label>
				<span class="howto"><?php _e('Choose the type of captcha you want to use as a security image on subscribe forms or turn off by choosing "None"', 'wp-mailinglist'); ?></span>
			</td>
		</tr>
	</tbody>
</table>

<!-- reCAPTCHA Settings -->
<?php

$recaptcha_publickey = $this -> get_option('recaptcha_publickey');
$recaptcha_privatekey = $this -> get_option('recaptcha_privatekey');
$recaptcha_type = $this -> get_option('recaptcha_type');
$recaptcha_language = $this -> get_option('recaptcha_language');
$recaptcha_theme = $this -> get_option('recaptcha_theme');
$recaptcha_customcss = $this -> get_option('recaptcha_customcss');

?>

<div id="recaptcha_div" style="display:<?php echo (!empty($captcha_type) && $captcha_type == "recaptcha") ? 'block' : 'none'; ?>;">
	<table class="form-table">
		<tbody>
			<tr>
				<th>&nbsp;</th>
				<td>
					<p><?php echo sprintf(__('In order to use reCAPTCHA, the public and private keys below are required.<br/>Go to the reCAPTCHA sign up and %screate a set of keys%s for this domain.', 'wp-mailinglist'), '<a href="https://www.google.com/recaptcha/admin/create" onclick="jQuery.colorbox({iframe:true, fastIframe:false, width:\'80%\', height:\'80%\', href:\'https://www.google.com/recaptcha/admin/create\'}); return false;">', '</a>'); ?></p>
				</td>
			</tr>
			<tr>
				<th><label for="recaptcha_type"><?php _e('reCAPTCHA Type', 'wp-mailinglist'); ?></label></th>
				<td>
					<label><input onclick="jQuery('#recaptcha_type_div_robot').show();" <?php echo (!empty($recaptcha_type) && $recaptcha_type == "robot") ? 'checked="checked"' : ''; ?> type="radio" name="recaptcha_type" value="robot" id="recaptcha_type_robot" /> <?php _e('Normal V2', 'wp-mailinglist'); ?></label>
					<label><input onclick="jQuery('#recaptcha_type_div_robot').hide();" <?php echo (empty($recaptcha_type) || $recaptcha_type == "invisible") ? 'checked="checked"' : ''; ?> type="radio" name="recaptcha_type" value="invisible" id="recaptcha_type_invisible" /> <?php _e('Invisible', 'wp-mailinglist'); ?></label>
					<span class="howto"><?php _e('Choose the reCAPTCHA integration to use, make sure your keys are valid for that integration.', 'wp-mailinglist'); ?></span>
				</td>
			</tr>
			<tr>
				<th><label for="recaptcha_publickey"><?php _e('Site Key', 'wp-mailinglist'); ?></label></th>
				<td>
					<input type="text" class="widefat" name="recaptcha_publickey" value="<?php echo esc_attr(stripslashes($recaptcha_publickey)); ?>" id="recaptcha_publickey" />
					<span class="howto"><?php _e('Site key provided by reCAPTCHA upon signing up.', 'wp-mailinglist'); ?></span>
				</td>
			</tr>
			<tr>
				<th><label for="recaptcha_privatekey"><?php _e('Secret Key', 'wp-mailinglist'); ?></label></th>
				<td>
					<input type="text" class="widefat" name="recaptcha_privatekey" value="<?php echo esc_attr(stripslashes($recaptcha_privatekey)); ?>" id="recaptcha_privatekey" /> 
					<span class="howto"><?php _e('Secret key provided by reCAPTCHA upon signing up.', 'wp-mailinglist'); ?></span>
				</td>
			</tr>
			<tr class="advanced-setting">
				<th><label for="recaptcha_language"><?php _e('Language', 'wp-mailinglist'); ?></label></th>
				<td>
					<input type="text" class="widefat" style="width:65px;" name="recaptcha_language" value="<?php echo esc_attr(stripslashes($recaptcha_language)); ?>" id="recaptcha_language" />
					<span class="howto"><?php echo sprintf(__('Language in which to display the captcha. See the %s', 'wp-mailinglist'), '<a href="https://developers.google.com/recaptcha/docs/language" target="_blank">' . __('language codes', 'wp-mailinglist') . '</a>'); ?></span>
				</td>
			</tr>
			<tr class="advanced-setting">
				<th><label for="recaptcha_theme"><?php _e('Theme', 'wp-mailinglist'); ?></label>
				<?php echo $Html -> help(__('Choose the reCAPTCHA theme to show to your users. Some premade themes by reCAPTCHA are available or you can use the Custom theme and style it according to your needs.', 'wp-mailinglist')); ?></th>
				<td>
					<?php $themes = array('light' => __('Light', 'wp-mailinglist'), 'dark' => __('Dark', 'wp-mailinglist')); ?>
					<select name="recaptcha_theme" id="recaptcha_theme">
						<option value=""><?php _e('- Select -', 'wp-mailinglist'); ?></option>
						<?php foreach ($themes as $theme_key => $theme_value) : ?>
							<option <?php echo (!empty($recaptcha_theme) && $recaptcha_theme == $theme_key) ? 'selected="selected"' : ''; ?> value="<?php echo $theme_key; ?>"><?php echo $theme_value; ?></option>
						<?php endforeach; ?>
					</select>
					<span class="howto"><?php _e('Pick the reCAPTCHA theme that you want to use.', 'wp-mailinglist'); ?></span>
				</td>
			</tr>
		</tbody>
	</table>
	
	<div id="recaptcha_type_div_robot" style="display:<?php echo (!empty($recaptcha_type) && $recaptcha_type == "robot") ? 'block' : 'none'; ?>;">
		
	</div>
</div>

<?php if ($this -> is_plugin_active('captcha')) : ?>
	<div id="rsc_div" style="display:<?php echo (!empty($captcha_type) && $captcha_type == "rsc") ? 'block' : 'none'; ?>;">
		
		<!-- Preview of Really Simple Captcha -->
		<?php 
						    	
    	$captcha = new ReallySimpleCaptcha();
    	$captcha -> bg = $Html -> hex2rgb($this -> get_option('captcha_bg')); 
    	$captcha -> fg = $Html -> hex2rgb($this -> get_option('captcha_fg'));
    	$captcha_size = $this -> get_option('captcha_size');
    	$captcha -> img_size = array($captcha_size['w'], $captcha_size['h']);
    	$captcha -> char_length = $this -> get_option('captcha_chars');
    	$captcha -> font_size = $this -> get_option('captcha_font');
    	$captcha_word = $captcha -> generate_random_word();
    	$captcha_prefix = mt_rand();
    	$captcha_filename = $captcha -> generate_image($captcha_prefix, $captcha_word);
        $captcha_file = plugins_url() . '/really-simple-captcha/tmp/' . $captcha_filename; 
    	
    	?>
		
		<!-- Really Simple Captcha Settings -->
		<table class="form-table">
			<tbody>
				<tr>
					<th><label for=""><?php _e('Preview', 'wp-mailinglist'); ?></label></th>
					<td>
						<div id="newsletters-captcha-preview">
							<img src="<?php echo $captcha_file; ?>" alt="captcha" />
						</div>
					</td>
				</tr>
				<tr>
					<th><label for="captcha_bg"><?php _e('Background Color', 'wp-mailinglist'); ?></label>
					<?php echo $Html -> help(__('The background color of the captcha image in hex code eg. #FFFFFF', 'wp-mailinglist')); ?></th>
					<td>				
						<div class="wp-picker-container">
							<a tabindex="0" id="captcha_bg_button" class="wp-color-result" style="background-color:<?php echo $this -> get_option('captcha_bg'); ?>; ?>;" title="<?php _e('Select Color', 'wp-mailinglist'); ?>"></a>
							<span class="wp-picker-input-wrap">
								<input type="text" name="captcha_bg" id="captcha_bg" value="<?php echo $this -> get_option('captcha_bg'); ?>" class="wp-color-picker" style="display:none;" />
							</span>
						</div>
						
						<script type="text/javascript">
						jQuery(document).ready(function() {
							jQuery('#captcha_bg').iris({
								hide: true,
								change: function(event, ui) {
									jQuery('#captcha_bg_button').css('background-color', ui.color.toString());
								}
							});
							
							jQuery('#captcha_bg').click(function(event) {
								event.stopPropagation();
							});
						
							jQuery('#captcha_bg_button').click(function(event) {							
								jQuery(this).attr('title', "<?php _e('Current Color', 'wp-mailinglist'); ?>");
								jQuery('#captcha_bg').iris('toggle').toggle();								
								event.stopPropagation();
							});
							
							jQuery('html').click(function() {
								jQuery('#captcha_bg').iris('hide').hide();
								jQuery('#captcha_bg_button').attr('title', "<?php _e('Select Color', 'wp-mailinglist'); ?>");
							});
						});
						</script>
						
						<span class="howto"><?php _e('Set the background color of the captcha image', 'wp-mailinglist'); ?></span>
					</td>
				</tr>
				<tr>
					<th><label for="captcha_fg"><?php _e('Text Color', 'wp-mailinglist'); ?></label>
					<?php echo $Html -> help(__('The foreground/text color of the text on the captcha image.', 'wp-mailinglist')); ?></th>
					<td>
						<div class="wp-picker-container">
							<a tabindex="0" id="captcha_fg_button" class="wp-color-result" style="background-color:<?php echo $this -> get_option('captcha_fg'); ?>; ?>;" title="<?php _e('Select Color', 'wp-mailinglist'); ?>"></a>
							<span class="wp-picker-input-wrap">
								<input type="text" name="captcha_fg" id="captcha_fg" value="<?php echo $this -> get_option('captcha_fg'); ?>" class="wp-color-picker" style="display:none;" />
							</span>
						</div>
						
						<script type="text/javascript">
						jQuery(document).ready(function() {
							jQuery('#captcha_fg').iris({
								hide: true,
								change: function(event, ui) {
									jQuery('#captcha_fg_button').css('background-color', ui.color.toString());
								}
							});
							
							jQuery('#captcha_fg').click(function(event) {
								event.stopPropagation();
							});
						
							jQuery('#captcha_fg_button').click(function(event) {							
								jQuery(this).attr('title', "<?php _e('Current Color', 'wp-mailinglist'); ?>");
								jQuery('#captcha_fg').iris('toggle').toggle();								
								event.stopPropagation();
							});
							
							jQuery('html').click(function() {
								jQuery('#captcha_fg').iris('hide').hide();
								jQuery('#captcha_fg_button').attr('title', "<?php _e('Select Color', 'wp-mailinglist'); ?>");
							});
						});
						</script>
						<span class="howto"><?php _e('Set the foreground/text color of the captcha image', 'wp-mailinglist'); ?></span>
					</td>
				</tr>
				<tr>
					<th><label for="captcha_size_w"><?php _e('Image Size', 'wp-mailinglist'); ?></label>
					<?php echo $Html -> help(__('Choose the size of the captcha image as it will display to your users. Fill in the width and the height of the image in pixels (px). The default is 72 by 24px which is optimal.', 'wp-mailinglist')); ?></th>
					<td>
						<?php $captcha_size = $this -> get_option('captcha_size'); ?>
						<input type="text" class="widefat" style="width:45px;" name="captcha_size[w]" value="<?php echo $captcha_size['w']; ?>" id="captcha_size_w" /> <?php _e('by', 'wp-mailinglist'); ?>
						<input type="text" class="widefat" style="width:45px;" name="captcha_size[h]" value="<?php echo $captcha_size['h']; ?>" id="captcha_size_h" /> <?php _e('px', 'wp-mailinglist'); ?>
						<span class="howto"><?php _e('Choose your preferred size for the captcha image.', 'wp-mailinglist'); ?></span>
					</td>
				</tr>
				<tr>
					<th><label for="captcha_chars"><?php _e('Number of Characters', 'wp-mailinglist'); ?></label>
					<?php echo $Html -> help(__('You can increase the number of characters to show in the captcha image to increase the security. Too many characters will make it difficult for your users though. The default is 4.', 'wp-mailinglist')); ?></th>
					<td>
						<input type="text" name="captcha_chars" value="<?php echo $this -> get_option('captcha_chars'); ?>" id="captcha_chars" class="widefat" style="width:45px;" /> <?php _e('characters', 'wp-mailinglist'); ?>
						<span class="howto"><?php _e('The number of characters to show in the captcha image.', 'wp-mailinglist'); ?></span>
					</td>
				</tr>
				<tr>
					<th><label for="captcha_font"><?php _e('Font Size', 'wp-mailinglist'); ?></label>
					<?php echo $Html -> help(__('A larger font will make the characters easier to read for your users. The default is 14 pixels.', 'wp-mailinglist')); ?></th>
					<td>
						<input type="text" name="captcha_font" value="<?php echo $this -> get_option('captcha_font'); ?>" id="captcha_font" class="widefat" style="width:45px;" /> <?php _e('px', 'wp-mailinglist'); ?>
						<span class="howto"><?php _e('Choose the font size of the characters on the captcha image.', 'wp-mailinglist'); ?></span>
					</td>
				</tr>
				<tr class="advanced-setting">
					<th><label for="captchainterval"><?php _e('Cleanup Interval', 'wp-mailinglist'); ?></label>
					<?php echo $Html -> help(__('To keep your server clean from old, unused captcha images a schedule will run at the interval specified to clean up old images. Set this to hourly or less as a recommended setting.', 'wp-mailinglist')); ?></th>
					<td>
						<?php $captchainterval = $this -> get_option('captchainterval'); ?>
		                <select class="widefat" style="width:auto;" id="captchainterval" name="captchainterval">
			                <option value=""><?php _e('- Select Interval -', 'wp-mailinglist'); ?></option>
			                <?php $schedules = wp_get_schedules(); ?>
			                <?php if (!empty($schedules)) : ?>
			                    <?php foreach ($schedules as $key => $val) : ?>
			                    <?php $sel = ($captchainterval == $key) ? 'selected="selected"' : ''; ?>
			                    <option <?php echo $sel; ?> value="<?php echo $key ?>"><?php echo $val['display']; ?> (<?php echo $val['interval'] ?> <?php _e('seconds', 'wp-mailinglist'); ?>)</option>
			                    <?php endforeach; ?>
			                <?php endif; ?>
		                </select>
						<span class="howto"><?php _e('The interval at which old captcha images will be removed from the server.', 'wp-mailinglist'); ?></span>
					</td>
				</tr>
			</tbody>
		</table>
	</div>
<?php endif; ?>